let instance

/**
 * 统一的音效管理器
 */
export default class Music {
  constructor() {
    if (instance) return instance

    instance = this

    this.bgmAudio = new Audio()
    this.bgmAudio.loop = true
    // this.bgmAudio.src = 'audio/bgm.mp3'
    this.bgmAudio.volume = 0.1;
    


    this.shootAudio = new Audio()
    this.shootAudio.src = 'audio/bullet.mp3'

    this.boomAudio = new Audio()
    this.boomAudio.src = 'audio/boom.mp3'

    // this.playBgm()
  }

  // bug 现象：播放并切换背景音乐之后，背景音乐的音量设置不生效了。
  playBgm1() {
    this.bgmAudio.src = "http://download.cocos.org/CocosTechnicalSupport/remote/audio/Bgm_General_3.mp3";
    this.bgmAudio.volume = 0.1;
    this.bgmAudio.play()
    setTimeout(()=>{
        this.bgmAudio.volume = 0.2;
    }, 2000)
    setTimeout(()=>{
      this.bgmAudio.volume = 0.5;
    }, 4000)
    setTimeout(()=>{
      this.bgmAudio.volume = 0.9;
    }, 6000)
  }

  playBgm2() {
    this.bgmAudio.src = "http://download.cocos.org/CocosTechnicalSupport/remote/audio/Bgm_Battle_1_Loop.mp3";
    this.bgmAudio.volume = 0.1;
    this.bgmAudio.play()
    setTimeout(()=>{
        this.bgmAudio.volume = 0.2;
    }, 2000)
    setTimeout(()=>{
      this.bgmAudio.volume = 0.5;
    }, 4000)
    setTimeout(()=>{
      this.bgmAudio.volume = 0.9;
    }, 6000)
  }

  playShoot() {
    this.shootAudio.currentTime = 0
    // this.shootAudio.play()
  }

  playExplosion() {
    this.boomAudio.currentTime = 0
    // this.boomAudio.play()
  }
}
